diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/test/wifi-mac-ofdma-test.cc ns-3.38/src/wifi/test/wifi-mac-ofdma-test.cc
--- ns-3.37/src/wifi/test/wifi-mac-ofdma-test.cc	2022-11-01 17:37:24.763395800 -0700
+++ ns-3.38/src/wifi/test/wifi-mac-ofdma-test.cc	2023-03-16 20:54:23.872869300 -0700
@@ -40,6 +40,8 @@
 #include "ns3/wifi-protection.h"
 #include "ns3/wifi-psdu.h"
 
+#include <iomanip>
+
 using namespace ns3;
 
 NS_LOG_COMPONENT_DEFINE("WifiMacOfdmaTestSuite");
@@ -85,6 +87,7 @@
     WifiTxVector m_txVector;          //!< the TX vector for MU PPDUs
     WifiTxParameters m_txParams;      //!< TX parameters
     WifiPsduMap m_psduMap;            //!< the DL MU PPDU to transmit
+    WifiModulationClass m_modClass;   //!< modulation class for DL MU PPDUs and TB PPDUs
 };
 
 NS_OBJECT_ENSURE_REGISTERED(TestMultiUserScheduler);
@@ -92,10 +95,16 @@
 TypeId
 TestMultiUserScheduler::GetTypeId()
 {
-    static TypeId tid = TypeId("ns3::TestMultiUserScheduler")
-                            .SetParent<MultiUserScheduler>()
-                            .SetGroupName("Wifi")
-                            .AddConstructor<TestMultiUserScheduler>();
+    static TypeId tid =
+        TypeId("ns3::TestMultiUserScheduler")
+            .SetParent<MultiUserScheduler>()
+            .SetGroupName("Wifi")
+            .AddConstructor<TestMultiUserScheduler>()
+            .AddAttribute("ModulationClass",
+                          "Modulation class for DL MU PPDUs and TB PPDUs.",
+                          EnumValue(WIFI_MOD_CLASS_HE),
+                          MakeEnumAccessor(&TestMultiUserScheduler::m_modClass),
+                          MakeEnumChecker(WIFI_MOD_CLASS_HE, "HE", WIFI_MOD_CLASS_EHT, "EHT"));
     return tid;
 }
 
@@ -133,19 +142,22 @@
             (m_txFormat == SU_TX || m_txFormat == DL_MU_TX ? TriggerFrameType::BSRP_TRIGGER
                                                            : TriggerFrameType::BASIC_TRIGGER);
 
-        m_trigger = CtrlTriggerHeader(ulTriggerType, m_txVector);
-
         WifiTxVector txVector = m_txVector;
+        txVector.SetPreambleType(m_modClass == WIFI_MOD_CLASS_HE ? WIFI_PREAMBLE_HE_TB
+                                                                 : WIFI_PREAMBLE_EHT_TB);
+        m_trigger = CtrlTriggerHeader(ulTriggerType, txVector);
+
         txVector.SetGuardInterval(m_trigger.GetGuardInterval());
 
         uint32_t ampduSize = (ulTriggerType == TriggerFrameType::BSRP_TRIGGER)
                                  ? GetMaxSizeOfQosNullAmpdu(m_trigger)
                                  : 3500; // allows aggregation of 2 MPDUs in TB PPDUs
 
-        Time duration = WifiPhy::CalculateTxDuration(ampduSize,
-                                                     txVector,
-                                                     m_apMac->GetWifiPhy()->GetPhyBand(),
-                                                     m_apMac->GetStaList().begin()->first);
+        Time duration =
+            WifiPhy::CalculateTxDuration(ampduSize,
+                                         txVector,
+                                         m_apMac->GetWifiPhy()->GetPhyBand(),
+                                         m_apMac->GetStaList(SINGLE_LINK_OP_ID).begin()->first);
 
         uint16_t length;
         std::tie(length, duration) = HePhy::ConvertHeTbPpduDurationToLSigLength(
@@ -170,7 +182,7 @@
         m_txParams.m_txVector =
             m_apMac->GetWifiRemoteStationManager()->GetRtsTxVector(m_triggerHdr.GetAddr1());
 
-        if (!m_heFem->TryAddMpdu(item, m_txParams, m_availableTime) ||
+        if (!GetHeFem(SINGLE_LINK_OP_ID)->TryAddMpdu(item, m_txParams, m_availableTime) ||
             (m_availableTime != Time::Min() &&
              m_txParams.m_protection->protectionTime + m_txParams.m_txDuration // TF tx time
                      + m_apMac->GetWifiPhy()->GetSifs() + duration +
@@ -188,7 +200,7 @@
     {
         // try to send a DL MU PPDU
         m_psduMap.clear();
-        const std::map<uint16_t, Mac48Address>& staList = m_apMac->GetStaList();
+        const std::map<uint16_t, Mac48Address>& staList = m_apMac->GetStaList(SINGLE_LINK_OP_ID);
         NS_ABORT_MSG_IF(staList.size() != 4, "There must be 4 associated stations");
 
         /* Initialize TX params */
@@ -227,8 +239,9 @@
             }
 
             std::vector<Ptr<WifiMpdu>> mpduList;
-            mpduList =
-                m_heFem->GetMpduAggregator()->GetNextAmpdu(mpdu, m_txParams, m_availableTime);
+            mpduList = GetHeFem(SINGLE_LINK_OP_ID)
+                           ->GetMpduAggregator()
+                           ->GetNextAmpdu(mpdu, m_txParams, m_availableTime);
 
             if (mpduList.size() > 1)
             {
@@ -260,7 +273,7 @@
 void
 TestMultiUserScheduler::ComputeWifiTxVector()
 {
-    if (m_txVector.GetPreambleType() == WIFI_PREAMBLE_HE_MU)
+    if (m_txVector.IsDlMu())
     {
         // the TX vector has been already computed
         return;
@@ -268,12 +281,18 @@
 
     uint16_t bw = m_apMac->GetWifiPhy()->GetChannelWidth();
 
-    m_txVector.SetPreambleType(WIFI_PREAMBLE_HE_MU);
+    m_txVector.SetPreambleType(m_modClass == WIFI_MOD_CLASS_HE ? WIFI_PREAMBLE_HE_MU
+                                                               : WIFI_PREAMBLE_EHT_MU);
+    if (IsEht(m_txVector.GetPreambleType()))
+    {
+        m_txVector.SetEhtPpduType(0);
+    }
     m_txVector.SetChannelWidth(bw);
     m_txVector.SetGuardInterval(m_apMac->GetHeConfiguration()->GetGuardInterval().GetNanoSeconds());
-    m_txVector.SetTxPowerLevel(GetWifiRemoteStationManager()->GetDefaultTxPowerLevel());
+    m_txVector.SetTxPowerLevel(
+        GetWifiRemoteStationManager(SINGLE_LINK_OP_ID)->GetDefaultTxPowerLevel());
 
-    const std::map<uint16_t, Mac48Address>& staList = m_apMac->GetStaList();
+    const std::map<uint16_t, Mac48Address>& staList = m_apMac->GetStaList(SINGLE_LINK_OP_ID);
     NS_ABORT_MSG_IF(staList.size() != 4, "There must be 4 associated stations");
 
     HeRu::RuType ruType;
@@ -309,8 +328,7 @@
             ruIndex = 1;
             primary80 = false;
         }
-        m_txVector.SetHeMuUserInfo(sta.first,
-                                   {{ruType, ruIndex++, primary80}, WifiMode("HeMcs11"), 1});
+        m_txVector.SetHeMuUserInfo(sta.first, {{ruType, ruIndex++, primary80}, 11, 1});
     }
     m_txVector.SetSigBMode(VhtPhy::GetVhtMcs5());
 }
@@ -332,6 +350,18 @@
 /**
  * \ingroup wifi-test
  * \ingroup tests
+ * The scenarios
+ */
+enum class WifiOfdmaScenario : uint8_t
+{
+    HE = 0, // HE AP and HE non-AP STAs
+    HE_EHT, // EHT AP, some EHT non-AP STAs and some non-EHT HE non-AP STAs
+    EHT     // EHT AP and EHT non-AP STAs
+};
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
  *
  * \brief Test OFDMA acknowledgment sequences
  *
@@ -367,13 +397,15 @@
      * \param txopLimit the TXOP limit in microseconds
      * \param nPktsPerSta number of packets to send to/receive from each station
      * \param muEdcaParameterSet the MU EDCA Parameter Set
+     * \param scenario the OFDMA scenario to test
      */
     OfdmaAckSequenceTest(uint16_t width,
                          WifiAcknowledgment::Method dlType,
                          uint32_t maxAmpduSize,
                          uint16_t txopLimit,
                          uint16_t nPktsPerSta,
-                         MuEdcaParameterSet muEdcaParameterSet);
+                         MuEdcaParameterSet muEdcaParameterSet,
+                         WifiOfdmaScenario scenario);
     ~OfdmaAckSequenceTest() override;
 
     /**
@@ -427,12 +459,16 @@
     Ptr<WifiNetDevice> m_apDevice;              ///< AP's device
     std::vector<PacketSocketAddress> m_sockets; ///< packet socket addresses for STAs
     uint16_t m_channelWidth;                    ///< PHY channel bandwidth in MHz
+    uint8_t m_muRtsRuAllocation;                ///< B7-B1 of RU Allocation subfield of MU-RTS
     std::vector<FrameInfo> m_txPsdus;           ///< transmitted PSDUs
     WifiAcknowledgment::Method m_dlMuAckType;   ///< DL MU ack sequence type
     uint32_t m_maxAmpduSize;                    ///< maximum A-MPDU size in bytes
     uint16_t m_txopLimit;                       ///< TXOP limit in microseconds
     uint16_t m_nPktsPerSta;                     ///< number of packets to send to each station
     MuEdcaParameterSet m_muEdcaParameterSet;    ///< MU EDCA Parameter Set
+    WifiOfdmaScenario m_scenario;               ///< OFDMA scenario to test
+    WifiPreamble m_dlMuPreamble;                ///< expected preamble type for DL MU PPDUs
+    WifiPreamble m_tbPreamble;                  ///< expected preamble type for TB PPDUs
     bool m_ulPktsGenerated;           ///< whether UL packets for HE TB PPDUs have been generated
     uint16_t m_received;              ///< number of packets received by the stations
     uint16_t m_flushed;               ///< number of DL packets flushed after DL MU PPDU
@@ -445,7 +481,8 @@
                                            uint32_t maxAmpduSize,
                                            uint16_t txopLimit,
                                            uint16_t nPktsPerSta,
-                                           MuEdcaParameterSet muEdcaParameterSet)
+                                           MuEdcaParameterSet muEdcaParameterSet,
+                                           WifiOfdmaScenario scenario)
     : TestCase("Check correct operation of DL OFDMA acknowledgment sequences"),
       m_nStations(4),
       m_sockets(m_nStations),
@@ -455,12 +492,43 @@
       m_txopLimit(txopLimit),
       m_nPktsPerSta(nPktsPerSta),
       m_muEdcaParameterSet(muEdcaParameterSet),
+      m_scenario(scenario),
       m_ulPktsGenerated(false),
       m_received(0),
       m_flushed(0),
       m_edcaDisabledStartTime(Seconds(0)),
       m_cwValues(std::vector<uint32_t>(m_nStations, 2)) // 2 is an invalid CW value
 {
+    switch (m_scenario)
+    {
+    case WifiOfdmaScenario::HE:
+    case WifiOfdmaScenario::HE_EHT:
+        m_dlMuPreamble = WIFI_PREAMBLE_HE_MU;
+        m_tbPreamble = WIFI_PREAMBLE_HE_TB;
+        break;
+    case WifiOfdmaScenario::EHT:
+        m_dlMuPreamble = WIFI_PREAMBLE_EHT_MU;
+        m_tbPreamble = WIFI_PREAMBLE_EHT_TB;
+        break;
+    }
+
+    switch (m_channelWidth)
+    {
+    case 20:
+        m_muRtsRuAllocation = 61; // p20 index is 0
+        break;
+    case 40:
+        m_muRtsRuAllocation = 65; // p20 index is 0
+        break;
+    case 80:
+        m_muRtsRuAllocation = 67;
+        break;
+    case 160:
+        m_muRtsRuAllocation = 68;
+        break;
+    default:
+        NS_ABORT_MSG("Unhandled channel width (" << m_channelWidth << " MHz)");
+    }
 }
 
 OfdmaAckSequenceTest::~OfdmaAckSequenceTest()
@@ -507,14 +575,16 @@
                         << (psdu->GetHeader(0).IsQosData()
                                 ? " TID " + std::to_string(*psdu->GetTids().begin())
                                 : "")
-                        << " txDuration " << txDuration << " duration/ID "
-                        << psdu->GetHeader(0).GetDuration() << " #TX PSDUs = " << m_txPsdus.size());
+                        << std::setprecision(10) << " txDuration " << txDuration << " duration/ID "
+                        << psdu->GetHeader(0).GetDuration() << " #TX PSDUs = " << m_txPsdus.size()
+                        << " size=" << (*psdu->begin())->GetSize() << "\n"
+                        << "TXVECTOR: " << txVector << "\n");
         }
     }
 
     // Flush the MAC queue of the AP after sending a DL MU PPDU (no need for
     // further transmissions)
-    if (txVector.GetPreambleType() == WIFI_PREAMBLE_HE_MU)
+    if (txVector.GetPreambleType() == m_dlMuPreamble)
     {
         m_flushed = 0;
         for (uint32_t i = 0; i < m_staDevices.GetN(); i++)
@@ -541,7 +611,7 @@
             }
         }
     }
-    else if (txVector.GetPreambleType() == WIFI_PREAMBLE_HE_TB &&
+    else if (txVector.GetPreambleType() == m_tbPreamble &&
              psduMap.begin()->second->GetHeader(0).HasData())
     {
         Mac48Address sender = psduMap.begin()->second->GetAddr2();
@@ -598,6 +668,7 @@
         {
             // the AP is starting the transmission of the Basic Trigger frame, so generate
             // the configured number of packets at STAs, which are sent in HE TB PPDUs
+            Time txDuration = WifiPhy::CalculateTxDuration(psduMap, txVector, WIFI_PHY_BAND_5GHZ);
             for (uint16_t i = 0; i < m_nStations; i++)
             {
                 Ptr<PacketSocketClient> client = CreateObject<PacketSocketClient>();
@@ -607,7 +678,7 @@
                 client->SetAttribute("Priority", UintegerValue(i * 2)); // 0, 2, 4 and 6
                 client->SetRemote(m_sockets[i]);
                 m_staDevices.Get(i)->GetNode()->AddApplication(client);
-                client->SetStartTime(Seconds(0));  // start now
+                client->SetStartTime(txDuration);  // start when TX ends
                 client->SetStopTime(Seconds(1.0)); // stop in a second
                 client->Initialize();
             }
@@ -622,48 +693,165 @@
     CtrlTriggerHeader trigger;
     CtrlBAckResponseHeader blockAck;
     Time tEnd;                         // TX end for a frame
-    Time tStart;                       // TX start fot the next frame
+    Time tStart;                       // TX start for the next frame
     Time tolerance = NanoSeconds(500); // due to propagation delay
     Time ifs = (m_txopLimit > 0 ? sifs : sifs + aifsn * slotTime);
     Time navEnd;
 
     /*
-     *                                                  |--------------NAV------------------>|
-     *                |------NAV------->|               |                 |------NAV-------->|
-     *      |---------|      |----------|     |---------|      |----------|      |-----------|
-     *      |         |      |QoS Null 1|     |         |      |QoS Data 1|      |           |
-     *      |  BSRP   |      |----------|     |  Basic  |      |----------|      | Multi-STA |
-     *      | Trigger |      |QoS Null 2|     | Trigger |      |QoS Data 2|      | Block Ack |
-     *      |  Frame  |<SIFS>|----------|<IFS>|  Frame  |<SIFS>|----------|<SIFS>|           |
-     *      |         |      |QoS Null 3|     |         |      |QoS Data 3|      |           |
-     *      |         |      |----------|     |         |      |----------|      |           |
-     *      |         |      |QoS Null 4|     |         |      |QoS Data 4|      |           |
-     * -----------------------------------------------------------------------------------------
-     * From:     AP                                AP                                 AP
-     *   To:    all               AP              all               AP               all
+     *        |-------------NAV----------->|         |-----------------NAV------------------->|
+     *                 |---------NAV------>|                  |--------------NAV------------->|
+     *                           |---NAV-->|                             |--------NAV-------->|
+     *    ┌───┐    ┌───┐    ┌────┐    ┌────┐     ┌───┐    ┌───┐    ┌─────┐    ┌────┐    ┌─────┐
+     *    │   │    │   │    │    │    │QoS │     │   │    │   │    │     │    │QoS │    │     │
+     *    │   │    │   │    │    │    │Null│     │   │    │   │    │     │    │Data│    │     │
+     *    │   │    │   │    │    │    ├────┤     │   │    │   │    │     │    ├────┤    │     │
+     *    │   │    │   │    │    │    │QoS │     │   │    │   │    │     │    │QoS │    │Multi│
+     *    │MU-│    │CTS│    │BSRP│    │Null│     │MU-│    │CTS│    │Basic│    │Data│    │-STA │
+     *    │RTS│SIFS│   │SIFS│ TF │SIFS├────┤<IFS>│RTS│SIFS│   │SIFS│ TF  │SIFS├────┤SIFS│Block│
+     *    │TF │    │x4 │    │    │    │QoS │     │TF │    │x4 │    │     │    │QoS │    │ Ack │
+     *    │   │    │   │    │    │    │Null│     │   │    │   │    │     │    │Data│    │     │
+     *    │   │    │   │    │    │    ├────┤     │   │    │   │    │     │    ├────┤    │     │
+     *    │   │    │   │    │    │    │QoS │     │   │    │   │    │     │    │QoS │    │     │
+     *    │   │    │   │    │    │    │Null│     │   │    │   │    │     │    │Data│    │     │
+     * ───┴───┴────┴───┴────┴────┴────┴────┴─────┴───┴────┴───┴────┴─────┴────┴────┴────┴─────┴──
+     * From: AP     all       AP        all       AP       all       AP         all       AP
+     *   To: all    AP        all       AP        all      AP        all        AP        all
      */
 
-    // the first packet sent after 1.5s is a BSRP Trigger Frame
-    NS_TEST_EXPECT_MSG_GT_OR_EQ(m_txPsdus.size(), 5, "Expected at least 5 transmitted packet");
+    // the first packet sent after 1.5s is an MU-RTS Trigger Frame
+    NS_TEST_ASSERT_MSG_GT_OR_EQ(m_txPsdus.size(), 5, "Expected at least 5 transmitted packet");
     NS_TEST_EXPECT_MSG_EQ((m_txPsdus[0].psduMap.size() == 1 &&
                            m_txPsdus[0].psduMap[SU_STA_ID]->GetHeader(0).IsTrigger() &&
                            m_txPsdus[0].psduMap[SU_STA_ID]->GetHeader(0).GetAddr1().IsBroadcast()),
                           true,
                           "Expected a Trigger Frame");
     m_txPsdus[0].psduMap[SU_STA_ID]->GetPayload(0)->PeekHeader(trigger);
+    NS_TEST_EXPECT_MSG_EQ(trigger.IsMuRts(), true, "Expected an MU-RTS Trigger Frame");
+    NS_TEST_EXPECT_MSG_EQ(trigger.GetNUserInfoFields(),
+                          4,
+                          "Expected one User Info field per station");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[0].txVector.GetChannelWidth(),
+                          m_channelWidth,
+                          "Expected the MU-RTS to occupy the entire channel width");
+    for (const auto& userInfo : trigger)
+    {
+        NS_TEST_EXPECT_MSG_EQ(+userInfo.GetMuRtsRuAllocation(),
+                              +m_muRtsRuAllocation,
+                              "Unexpected RU Allocation value in MU-RTS");
+    }
+    tEnd = m_txPsdus[0].endTx;
+    navEnd = tEnd + m_txPsdus[0].psduMap[SU_STA_ID]->GetDuration();
+
+    // A first STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
+    NS_TEST_EXPECT_MSG_EQ(
+        (m_txPsdus[1].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
+         m_txPsdus[1].psduMap.size() == 1 &&
+         m_txPsdus[1].psduMap.begin()->second->GetNMpdus() == 1 &&
+         m_txPsdus[1].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
+        true,
+        "Expected a CTS frame");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[1].txVector.GetChannelWidth(),
+                          m_channelWidth,
+                          "Expected the CTS to occupy the entire channel width");
+
+    tStart = m_txPsdus[1].startTx;
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
+    Time ctsNavEnd = m_txPsdus[1].endTx + m_txPsdus[1].psduMap[SU_STA_ID]->GetDuration();
+    // navEnd <= ctsNavEnd < navEnd + tolerance
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
+    NS_TEST_EXPECT_MSG_LT(ctsNavEnd, navEnd + tolerance, "Duration/ID in CTS frame is too long");
+
+    // A second STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
+    NS_TEST_EXPECT_MSG_EQ(
+        (m_txPsdus[2].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
+         m_txPsdus[2].psduMap.size() == 1 &&
+         m_txPsdus[2].psduMap.begin()->second->GetNMpdus() == 1 &&
+         m_txPsdus[2].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
+        true,
+        "Expected a CTS frame");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[2].txVector.GetChannelWidth(),
+                          m_channelWidth,
+                          "Expected the CTS to occupy the entire channel width");
+
+    tStart = m_txPsdus[2].startTx;
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
+    ctsNavEnd = m_txPsdus[2].endTx + m_txPsdus[2].psduMap[SU_STA_ID]->GetDuration();
+    // navEnd <= ctsNavEnd < navEnd + tolerance
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
+    NS_TEST_EXPECT_MSG_LT(ctsNavEnd, navEnd + tolerance, "Duration/ID in CTS frame is too long");
+
+    // A third STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
+    NS_TEST_EXPECT_MSG_EQ(
+        (m_txPsdus[3].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
+         m_txPsdus[3].psduMap.size() == 1 &&
+         m_txPsdus[3].psduMap.begin()->second->GetNMpdus() == 1 &&
+         m_txPsdus[3].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
+        true,
+        "Expected a CTS frame");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[3].txVector.GetChannelWidth(),
+                          m_channelWidth,
+                          "Expected the CTS to occupy the entire channel width");
+
+    tStart = m_txPsdus[3].startTx;
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
+    ctsNavEnd = m_txPsdus[3].endTx + m_txPsdus[3].psduMap[SU_STA_ID]->GetDuration();
+    // navEnd <= ctsNavEnd < navEnd + tolerance
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
+    NS_TEST_EXPECT_MSG_LT(ctsNavEnd, navEnd + tolerance, "Duration/ID in CTS frame is too long");
+
+    // A fourth STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
+    NS_TEST_EXPECT_MSG_EQ(
+        (m_txPsdus[4].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
+         m_txPsdus[4].psduMap.size() == 1 &&
+         m_txPsdus[4].psduMap.begin()->second->GetNMpdus() == 1 &&
+         m_txPsdus[4].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
+        true,
+        "Expected a CTS frame");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[4].txVector.GetChannelWidth(),
+                          m_channelWidth,
+                          "Expected the CTS to occupy the entire channel width");
+
+    tStart = m_txPsdus[4].startTx;
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
+    ctsNavEnd = m_txPsdus[4].endTx + m_txPsdus[4].psduMap[SU_STA_ID]->GetDuration();
+    // navEnd <= ctsNavEnd < navEnd + tolerance
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
+    NS_TEST_EXPECT_MSG_LT(ctsNavEnd, navEnd + tolerance, "Duration/ID in CTS frame is too long");
+
+    // the AP sends a BSRP Trigger Frame
+    NS_TEST_ASSERT_MSG_GT_OR_EQ(m_txPsdus.size(), 10, "Expected at least 10 transmitted packet");
+    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[5].psduMap.size() == 1 &&
+                           m_txPsdus[5].psduMap[SU_STA_ID]->GetHeader(0).IsTrigger() &&
+                           m_txPsdus[5].psduMap[SU_STA_ID]->GetHeader(0).GetAddr1().IsBroadcast()),
+                          true,
+                          "Expected a Trigger Frame");
+    m_txPsdus[5].psduMap[SU_STA_ID]->GetPayload(0)->PeekHeader(trigger);
     NS_TEST_EXPECT_MSG_EQ(trigger.IsBsrp(), true, "Expected a BSRP Trigger Frame");
     NS_TEST_EXPECT_MSG_EQ(trigger.GetNUserInfoFields(),
                           4,
                           "Expected one User Info field per station");
+    tEnd = m_txPsdus[4].endTx;
+    tStart = m_txPsdus[5].startTx;
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "BSRP Trigger Frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "BSRP Trigger Frame sent too late");
+    Time bsrpNavEnd = m_txPsdus[5].endTx + m_txPsdus[5].psduMap[SU_STA_ID]->GetDuration();
+    // navEnd <= bsrpNavEnd < navEnd + tolerance
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, bsrpNavEnd, "Duration/ID in BSRP TF is too short");
+    NS_TEST_EXPECT_MSG_LT(bsrpNavEnd, navEnd + tolerance, "Duration/ID in BSRP TF is too long");
 
-    // A first STA sends a QoS Null frame in an HE TB PPDU a SIFS after the reception of the BSRP TF
-    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[1].txVector.GetPreambleType() == WIFI_PREAMBLE_HE_TB &&
-                           m_txPsdus[1].psduMap.size() == 1 &&
-                           m_txPsdus[1].psduMap.begin()->second->GetNMpdus() == 1),
+    // A first STA sends a QoS Null frame in a TB PPDU a SIFS after the reception of the BSRP TF
+    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[6].txVector.GetPreambleType() == m_tbPreamble &&
+                           m_txPsdus[6].psduMap.size() == 1 &&
+                           m_txPsdus[6].psduMap.begin()->second->GetNMpdus() == 1),
                           true,
-                          "Expected a QoS Null frame in an HE TB PPDU");
+                          "Expected a QoS Null frame in a TB PPDU");
     {
-        const WifiMacHeader& hdr = m_txPsdus[1].psduMap.begin()->second->GetHeader(0);
+        const WifiMacHeader& hdr = m_txPsdus[6].psduMap.begin()->second->GetHeader(0);
         NS_TEST_EXPECT_MSG_EQ(hdr.GetType(), WIFI_MAC_QOSDATA_NULL, "Expected a QoS Null frame");
         uint16_t staId;
         for (staId = 0; staId < m_nStations; staId++)
@@ -677,26 +865,31 @@
         uint8_t tid = staId * 2;
         NS_TEST_EXPECT_MSG_EQ(+hdr.GetQosTid(), +tid, "Expected a TID equal to " << +tid);
     }
-    tEnd = m_txPsdus[0].endTx;
-    navEnd = tEnd + m_txPsdus[0].psduMap[SU_STA_ID]->GetDuration();
-    tStart = m_txPsdus[1].startTx;
+    tEnd = m_txPsdus[5].endTx;
+    tStart = m_txPsdus[6].startTx;
     NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "QoS Null frame in HE TB PPDU sent too early");
     NS_TEST_EXPECT_MSG_LT(tStart,
                           tEnd + sifs + tolerance,
                           "QoS Null frame in HE TB PPDU sent too late");
-    NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                m_txPsdus[1].endTx,
-                                "Duration/ID in BSRP Trigger Frame is too short");
-
-    // A second STA sends a QoS Null frame in an HE TB PPDU a SIFS after the reception of the BSRP
-    // TF
-    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[2].txVector.GetPreambleType() == WIFI_PREAMBLE_HE_TB &&
-                           m_txPsdus[2].psduMap.size() == 1 &&
-                           m_txPsdus[2].psduMap.begin()->second->GetNMpdus() == 1),
+    Time qosNullNavEnd = m_txPsdus[6].endTx + m_txPsdus[6].psduMap.begin()->second->GetDuration();
+    if (m_txopLimit == 0)
+    {
+        NS_TEST_EXPECT_MSG_EQ(qosNullNavEnd,
+                              m_txPsdus[6].endTx,
+                              "Expected null Duration/ID for QoS Null frame in HE TB PPDU");
+    }
+    // navEnd <= qosNullNavEnd < navEnd + tolerance
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, qosNullNavEnd, "Duration/ID in QoS Null is too short");
+    NS_TEST_EXPECT_MSG_LT(qosNullNavEnd, navEnd + tolerance, "Duration/ID in QoS Null is too long");
+
+    // A second STA sends a QoS Null frame in a TB PPDU a SIFS after the reception of the BSRP TF
+    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[7].txVector.GetPreambleType() == m_tbPreamble &&
+                           m_txPsdus[7].psduMap.size() == 1 &&
+                           m_txPsdus[7].psduMap.begin()->second->GetNMpdus() == 1),
                           true,
-                          "Expected a QoS Null frame in an HE TB PPDU");
+                          "Expected a QoS Null frame in a TB PPDU");
     {
-        const WifiMacHeader& hdr = m_txPsdus[2].psduMap.begin()->second->GetHeader(0);
+        const WifiMacHeader& hdr = m_txPsdus[7].psduMap.begin()->second->GetHeader(0);
         NS_TEST_EXPECT_MSG_EQ(hdr.GetType(), WIFI_MAC_QOSDATA_NULL, "Expected a QoS Null frame");
         uint16_t staId;
         for (staId = 0; staId < m_nStations; staId++)
@@ -710,23 +903,30 @@
         uint8_t tid = staId * 2;
         NS_TEST_EXPECT_MSG_EQ(+hdr.GetQosTid(), +tid, "Expected a TID equal to " << +tid);
     }
-    tStart = m_txPsdus[2].startTx;
+    tStart = m_txPsdus[7].startTx;
     NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "QoS Null frame in HE TB PPDU sent too early");
     NS_TEST_EXPECT_MSG_LT(tStart,
                           tEnd + sifs + tolerance,
                           "QoS Null frame in HE TB PPDU sent too late");
-    NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                m_txPsdus[2].endTx,
-                                "Duration/ID in BSRP Trigger Frame is too short");
-
-    // A third STA sends a QoS Null frame in an HE TB PPDU a SIFS after the reception of the BSRP TF
-    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[3].txVector.GetPreambleType() == WIFI_PREAMBLE_HE_TB &&
-                           m_txPsdus[3].psduMap.size() == 1 &&
-                           m_txPsdus[3].psduMap.begin()->second->GetNMpdus() == 1),
+    qosNullNavEnd = m_txPsdus[7].endTx + m_txPsdus[7].psduMap.begin()->second->GetDuration();
+    if (m_txopLimit == 0)
+    {
+        NS_TEST_EXPECT_MSG_EQ(qosNullNavEnd,
+                              m_txPsdus[7].endTx,
+                              "Expected null Duration/ID for QoS Null frame in HE TB PPDU");
+    }
+    // navEnd <= qosNullNavEnd < navEnd + tolerance
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, qosNullNavEnd, "Duration/ID in QoS Null is too short");
+    NS_TEST_EXPECT_MSG_LT(qosNullNavEnd, navEnd + tolerance, "Duration/ID in QoS Null is too long");
+
+    // A third STA sends a QoS Null frame in a TB PPDU a SIFS after the reception of the BSRP TF
+    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[8].txVector.GetPreambleType() == m_tbPreamble &&
+                           m_txPsdus[8].psduMap.size() == 1 &&
+                           m_txPsdus[8].psduMap.begin()->second->GetNMpdus() == 1),
                           true,
                           "Expected a QoS Null frame in an HE TB PPDU");
     {
-        const WifiMacHeader& hdr = m_txPsdus[3].psduMap.begin()->second->GetHeader(0);
+        const WifiMacHeader& hdr = m_txPsdus[8].psduMap.begin()->second->GetHeader(0);
         NS_TEST_EXPECT_MSG_EQ(hdr.GetType(), WIFI_MAC_QOSDATA_NULL, "Expected a QoS Null frame");
         uint16_t staId;
         for (staId = 0; staId < m_nStations; staId++)
